#include <bits/stdc++.h>
using namespace std;
int n, res, br[5], m[10005][5];
int bro, bra, brb, brab, o, a, b, ab, O, A, B, AB, br2, br3;
struct slog{
    string kg;
    int k, ID, res[5], s;
}pacijent[10005];
bool cmp(slog a, slog b){
    return a.s<b.s;
}
bool cmp1(slog a, slog b){
    return a.ID<b.ID;
}
int main()
{
    /* zapamti za ispis
    for(int i=1; i<=4; i++){
        cout<<pacijent[1].res[i]<<endl;
    }*/
    cin>>n>>o>>a>>b>>ab;
    O=o;
    A=a;
    B=b;
    AB=ab;
    for(int i=1; i<=n; i++){
        cin>>pacijent[i].kg>>pacijent[i].k;
        pacijent[i].ID=i;
        //za brojac
        {
        if(pacijent[i].kg=="O") br[1]+=pacijent[i].k, pacijent[i].s=1;
        else if(pacijent[i].kg=="A") br[2]+=pacijent[i].k, pacijent[i].s=2;
        else if(pacijent[i].kg=="B") br[3]+=pacijent[i].k, pacijent[i].s=3;
        else br[4]+=pacijent[i].k, pacijent[i].s=4;
        }
    }
    if(br[1]>o){
        cout<<"nemoguce"<<endl;
        return 0;
    }
    O-=br[1];
    A-=br[2];
    B-=br[3];
    if(A<0) A=0;
    if(B<0) B=0;
    br[2]-=a;
    br[3]-=b;
    if(br[2]<0) br[2]=0;
    if(br[3]<0) br[3]=0;
    if((br[2]+br[3])>O){
        cout<<"nemoguce"<<endl;
        return 0;
    }
    O-=br[2]+br[3];
    if(O<0) O=0;
    if(br[4]>(A+B+O+AB)){
        cout<<"nemoguce"<<endl;
        return 0;
    }
    //cout<<"O "<<o<<" A "<<a<<" B "<<b<<" AB "<<ab<<endl;
    cout<<"moguce"<<endl;


    sort(pacijent+1, pacijent+1+n, cmp);
    for(int i=1; i<=n; i++){
//        cout<<pacijent[i].kg<<endl;
        if(pacijent[i].kg=="O") {
            pacijent[i].res[1]=pacijent[i].k;
            //o-=pacijent[i].k;
        }
        else if(pacijent[i].kg=="A"){
            if(a!=0){
                if(a>=pacijent[i].k){
                    pacijent[i].res[2]=pacijent[i].k;
                    a-=pacijent[i].k;
                }
                else {
                    pacijent[i].res[2]=a;
                    pacijent[i].res[1]=pacijent[i].k-a;
                    //o-=pacijent[i].k-a;
                    a=0;
                }
            }
            else{
                pacijent[i].res[1]=pacijent[i].k;
                //o-=pacijent[i].k;
            }
        }
        else if(pacijent[i].kg=="B"){
            if(b!=0){
                if(b>=pacijent[i].k){
                    pacijent[i].res[3]=pacijent[i].k;
                    b-=pacijent[i].k;
                }
                else {
                    pacijent[i].res[3]=b;
                    pacijent[i].res[1]=pacijent[i].k-b;
                    //o-=pacijent[i].k-b;
                    b=0;
                }
            }
            else{
                pacijent[i].res[1]=pacijent[i].k;
                //o-=pacijent[i].k;
            }
        }
        else {
            if(ab!=0){
                if(ab>=pacijent[i].k){
                    pacijent[i].res[4]=pacijent[i].k;
                    ab-pacijent[i].k;
                }
                else{
                    pacijent[i].res[4]=ab;
                    pacijent[i].res[1]=pacijent[i].k-ab;
                    //o-=pacijent[i].k-ab;
                    ab=0;
                }
            }

            else if(a!=0){
                if(a>=pacijent[i].k){
                    pacijent[i].res[2]=pacijent[i].k;
                    a-=pacijent[i].k;
                }
                else {
                    pacijent[i].res[2]=a;
                    pacijent[i].res[1]=pacijent[i].k-a;
                    //o-=pacijent[i].k-a;
                    a=0;
                }
            }

            else if(b!=0){
                if(b>=pacijent[i].k){
                    pacijent[i].res[3]=pacijent[i].k;
                    b-=pacijent[i].k;
                }
                else {
                    pacijent[i].res[3]=b;
                    pacijent[i].res[1]=pacijent[i].k-b;
                    //o-=pacijent[i].k-b;
                    b=0;
                }
            }
            else{
                pacijent[i].res[1]=pacijent[i].k;
                //o-=pacijent[i].k;
            }
        }
    }
    sort(pacijent+1, pacijent+1+n, cmp1);
    for(int i=1; i<=n; i++){
            //cout<<pacijent[i].kg<<" ";
        for(int j=1; j<=4; j++){
            cout<<pacijent[i].res[j]<<" ";
        }
        cout<<endl;
    }

    return 0;
}